web-dev-qa-db-ja.com

ファイルが変更されているかどうかを常に確認するbash

スクリプトに追加したいfile1というファイルがあります。ファイルに変更があったときはいつでも、実際にはビープ音が鳴ります。それ、どうやったら出来るの?

8
aDoN

inotify-toolsがインストールされている場合(少なくともDebianではパッケージ名です)、次のようなことができます。

while inotifywait -q -e modify filename >/dev/null; do
    echo "filename is changed"
    # do whatever else you need to do
done

これは、「変更」イベントが「ファイル名」という名前のファイルに発生するのを待ちます。これが発生すると、inotifywaitコマンドはfilename MODIFY(/ dev/nullに出力を送信して破棄する)を出力して終了し、ループの本体に入ります。

その他の可能性については、inotifywaitのマンページをお読みください。

14
wurtel

MacOSでワンライナーを探しに来ました。以下で解決。コンパイルして this tool をパスに追加しました。これには30秒もかかりませんでした。

$ git clone [email protected]:sschober/kqwait.git
$ cd kqwait
$ make
$ mv kqwait ~/bin
$ chmod +x ~/bin/kqwait

次に、見たいと思ったディレクトリに行きました。この場合、マークダウンファイルの変更を監視し、変更された場合はmakeを発行したいと考えていました。

$ while true; do kqwait doc/my_file.md; make; done

それでおしまい。

2
Joshua Cook

Inotifywaitがなくても、次の小さなスクリプトとcronジョブ(毎分程度)を使用できます。

#!/usr/bin/env bash
#
# Provides      : Check if a file is changed
# 
# Limitations   : none
# Options       : none
# Requirements  : bash, md5sum, cut
# 
# Modified      : 11|07|2014
# Author        : ItsMe
# Reply to      : n/a in public
#
# Editor        : joe
#
#####################################
#
# OK - lets work
#

# what file do we want to monitor?
# I did not include commandline options
# but its easy to catch a command line option
# and replace the defaul given here
file=/foo/bar/nattebums/bla.txt

# path to file's saved md5sum
# I did not spend much effort in naming this file
# if you ahve to test multiple files
# so just use a commandline option and use the given
# file name like: filename=$(basename "$file")
fingerprintfile=/tmp/.bla.md5savefile

# does the file exist?
if [ ! -f $file ]
    then
        echo "ERROR: $file does not exist - aborting"
    exit 1
fi

# create the md5sum from the file to check
filemd5=`md5sum $file | cut -d " " -f1`

# check the md5 and
# show an error when we check an empty file
if [ -z $filemd5 ]
    then
        echo "The file is empty - aborting"
        exit 1
    else
        # pass silent
        :
fi

# do we have allready an saved fingerprint of this file?
if [ -f $fingerprintfile ]
    then
        # yup - get the saved md5
        savedmd5=`cat $fingerprintfile`

        # check again if its empty
        if [ -z $savedmd5 ]
            then
                echo "The file is empty - aborting"
                exit 1
        fi

        #compare the saved md5 with the one we have now
        if [ "$savedmd5" = "$filemd5" ]
            then
                # pass silent
                :
            else
                echo "File has been changed"

                # this does an beep on your pc speaker (probably)
                # you get this character when you do:
                # CTRL+V CTRL+G
                # this is a bit creepy so you can use the 'beep' command
                # of your distro
                # or run some command you want to
                echo 
        fi

fi

# save the current md5
# sure you don't have to do this when the file hasn't changed
# but you know I'm lazy and it works...
echo $filemd5 > $fingerprintfile
2
ItsMe

git repoで変更を確認する場合は、次を使用できます。

#!/usr/bin/env bash

diff="$(git diff | egrep some_file_name_or_file_path | cat)"

if [[ -n "$diff" ]] ; then
    echo "==== Found changes: ===="
    echo "diff: $diff"
    exit 1
else
    echo 'Code is not changed'
fi

0
Alon Gouldman
Done in 2 steps Tested and worked fine in both scenarios

a。 cp orginalfile fileneedto_be_changed '(1回のみ実行する必要があります)

orginalfile=====>which supposed to be changed

b。

differencecount=`awk 'NR==FNR{a[$0];next}!($0 in a){print $0}' orginalfile fileneedto_be_changed|wc -l`

if [ $differencecount -eq  0 ]
then
echo "NO changes in file"
else
echo "Noted there is changes in file"
fi
0

entr コマンドラインツールを試すことができます。

$ ls file1 | entr beep
0
kenorb

利用可能なdiffユーティリティがある場合は、おそらくmd5sumを比較する必要はありません。

if ! diff "$file1" "$file2" >/dev/null 2>&1; then
  echo "$file1 and $file2 does not match" >&2
  ## INSERT-YOUR-COMMAND/SCRIPT-HERE
  ## e.g. cp "$file1" "$file2"
fi

!否定するステートメントがfalseの場合はtrue

警告は、上記のmd5sumスクリプトが実行しているものと同じ(imo)diffと比較するために元のファイルが必要なことです。

0
Jetchisel